diff --git a/web/pgadmin/tools/debugger/static/js/components/DebuggerEditor.jsx b/web/pgadmin/tools/debugger/static/js/components/DebuggerEditor.jsx
new file mode 100644
index 00000000..6d22fcea
--- /dev/null
+++ b/web/pgadmin/tools/debugger/static/js/components/DebuggerEditor.jsx
@@ -0,0 +1,120 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import { makeStyles } from '@material-ui/styles';
+import PropTypes from 'prop-types';
+
+import React, { useContext, useEffect } from 'react';
+
+import gettext from 'sources/gettext';
+import url_for from 'sources/url_for';
+
+import getApiInstance from '../../../../../static/js/api_instance';
+import CodeMirror from '../../../../../static/js/components/CodeMirror';
+import Notify from '../../../../../static/js/helpers/Notifier';
+import { DEBUGGER_EVENTS } from '../DebuggerConstants';
+import { DebuggerEventsContext } from './DebuggerComponent';
+
+
+const useStyles = makeStyles(() => ({
+  sql: {
+    height: '100%',
+  }
+}));
+
+export default function DebuggerEditor({ getEditor, params }) {
+  const classes = useStyles();
+  const editor = React.useRef();
+  const eventBus = useContext(DebuggerEventsContext);
+  
+  const api = getApiInstance();
+
+  function makeMarker() {
+    var marker = document.createElement('div');
+    marker.style.color = '#822';
+    marker.innerHTML = '●';
+    return marker;
+  }
+
+  function setBreakpoint(lineNo, setType) {
+    // Make ajax call to set/clear the break point by user
+    var baseUrl = url_for('debugger.set_breakpoint', {
+      'trans_id': params.transId,
+      'line_no': lineNo,
+      'set_type': setType,
+    });
+    api({
+      url: baseUrl,
+      method: 'GET',
+    })
+      .then(function(res) {
+        if (res.data.data.status) {
+        // Breakpoint has been set by the user
+        }
+      })
+      .catch(function() {
+        Notify.alert(
+          gettext('Debugger Error'),
+          gettext('Error while setting debugging breakpoint.')
+        );
+      });
+  }
+
+  function onBreakPoint(cm, n, gutter) {
+    // If breakpoint gutter is clicked and execution is not completed then only set the breakpoint
+    if (gutter == 'breakpoints' && !params.debuggerDirect.polling_timeout_idle) {
+      var info = cm.lineInfo(n);
+      // If gutterMarker is undefined that means there is no marker defined previously
+      // So we need to set the breakpoint command here...
+      if (info.gutterMarkers == undefined) {
+        setBreakpoint(n + 1, 1); //set the breakpoint
+      } else {
+        if (info.gutterMarkers.breakpoints == undefined) {
+          setBreakpoint(n + 1, 1); //set the breakpoint
+        } else {
+          setBreakpoint(n + 1, 0); //clear the breakpoint
+        }
+      }
+
+      // If line folding is defined then gutterMarker will be defined so
+      // we need to find out 'breakpoints' information
+      var markers = info.gutterMarkers;
+      if (markers != undefined && info.gutterMarkers.breakpoints == undefined)
+        markers = info.gutterMarkers.breakpoints;
+      cm.setGutterMarker(n, 'breakpoints', markers ? null : makeMarker());
+    }
+  }
+
+  eventBus.registerListener(DEBUGGER_EVENTS.EDITOR_SET_SQL, (value, focus = true) => {
+    focus && editor.current?.focus();
+    editor.current?.setValue(value);
+  });
+
+  useEffect(() => {
+    self = this;
+    // Register the callback when user set/clear the breakpoint on gutter area.
+    editor.current.on('gutterClick', onBreakPoint);
+    getEditor(editor.current);
+  }, [editor.current]);
+  return (
+    <CodeMirror
+      currEditor={(obj) => {
+        editor.current = obj;
+      }}
+      gutters={['CodeMirror-linenumbers', 'CodeMirror-foldgutter', 'breakpoints']}
+      value={''}
+      className={classes.sql}
+      disabled={true}
+    />);
+}
+
+DebuggerEditor.propTypes = { 
+  getEditor: PropTypes.func,
+  params: PropTypes.object
+};
\ No newline at end of file
diff --git a/web/pgadmin/tools/debugger/static/js/components/LocalVariablesAndParams.jsx b/web/pgadmin/tools/debugger/static/js/components/LocalVariablesAndParams.jsx
new file mode 100644
index 00000000..0fe32faa
--- /dev/null
+++ b/web/pgadmin/tools/debugger/static/js/components/LocalVariablesAndParams.jsx
@@ -0,0 +1,147 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import _ from 'lodash';
+import clsx from 'clsx';
+import PropTypes from 'prop-types';
+
+import React, { useCallback, useState } from 'react';
+
+import { makeStyles } from '@material-ui/styles';
+import Paper from '@material-ui/core/Paper';
+import TableContainer from '@material-ui/core/TableContainer';
+
+import gettext from 'sources/gettext';
+
+import { DebuggerEventsContext } from './DebuggerComponent';
+import { DEBUGGER_EVENTS } from '../DebuggerConstants';
+import { commonTableStyles } from '../../../../../static/js/Theme';
+import { InputText } from '../../../../../static/js/components/FormComponents';
+
+
+const useStyles = makeStyles(() => ({
+  table: {
+    minWidth: 650,
+  },
+  summaryContainer: {
+    flexGrow: 1,
+    minHeight: 0,
+    overflow: 'auto',
+    maxHeight: '100%'
+  },
+  container: {
+    maxHeight: '100%'
+  },
+  cell: {
+    textAlign: 'center'
+  }
+
+}));
+
+export function LocalVariablesAndParams({type}) {
+  /* For Parameters and Local variables same component.
+        {
+         1: 'Parameters'
+         2: 'LocalVariables'
+        } 
+    */
+  const classes = useStyles();
+  const tableClasses = commonTableStyles();
+  const eventBus = React.useContext(DebuggerEventsContext);
+  const [variablesData, setVariablesData] = useState([]);
+  const preValue = React.useRef('NULL');
+
+
+  React.useEffect(() => {
+    if(type == 1) {
+      eventBus.registerListener(DEBUGGER_EVENTS.SET_PARAMETERS, (val) => {
+        setVariablesData(val);
+      });
+    } else if(type == 2) {
+      eventBus.registerListener(DEBUGGER_EVENTS.SET_LOCAL_VARIABLES, (val) => {
+        setVariablesData(val);
+      });
+    }
+  }, []);
+
+  const changeLocalVarVal = useCallback((data) => {
+    if(type == 1) {
+      eventBus.fireEvent(DEBUGGER_EVENTS.SET_PARAMETERS_VALUE_CHANGE, data);
+    } else if(type == 2) {
+      eventBus.fireEvent(DEBUGGER_EVENTS.SET_LOCAL_VARIABLE_VALUE_CHANGE, data);
+    }
+        
+  });
+
+  const onValueChange = (name, value) => {
+    setVariablesData((prev) => {
+      let retVal = [...prev];
+      if(preValue.current != 'NULL'){
+        preValue.current = value;
+      }
+      let nameIndex = _.findIndex(retVal, (r) => (r.name == name));
+      retVal[nameIndex].value = value;
+      return retVal;
+    });
+  };
+
+  return (
+    <Paper variant="outlined" elevation={0} className={classes.summaryContainer}>
+      <TableContainer className={classes.container}>
+        <table className={clsx(tableClasses.table)} aria-label="sticky table">
+          <thead>
+            <tr>
+              <th>{gettext('Name')}</th>
+              <th>{gettext('Type')}</th>
+              <th>{gettext('Value')}</th>
+            </tr>
+          </thead>
+          <tbody>
+            {variablesData.map((row) => (
+              <tr key={row.name}>
+                <td>{row.name}</td>
+                <td>{row.dtype}</td>
+                <td><InputText value={row.value} type={'text'}
+                  onChange={(val) => {
+                    onValueChange(row.name, val);
+                  }}
+                  onFocus={()=> {
+                    preValue.current = row.value;
+                  }}
+                  onBlur={() => {
+                    let data = [{
+                      name: row.name,
+                      value: row.value,
+                      type: row.type
+                    }];
+                    if(preValue.current != row.value){
+                      preValue.current = row.value;
+                      changeLocalVarVal(data);
+                    }
+                                    
+                  }}
+                ></InputText> </td>
+              </tr>
+            ))}
+            {
+              variablesData.length == 0 && 
+                    <tr key={_.uniqueId('c')} className={classes.cell}>
+                      <td colSpan={3} >{gettext('No data found')}</td>
+                    </tr>
+            }
+                    
+          </tbody>
+        </table>
+      </TableContainer>
+    </Paper>
+  );
+}
+
+LocalVariablesAndParams.propTypes = {
+  type: PropTypes.number
+};
diff --git a/web/pgadmin/tools/debugger/static/js/components/Messages.jsx b/web/pgadmin/tools/debugger/static/js/components/Messages.jsx
new file mode 100644
index 00000000..e44b3ad5
--- /dev/null
+++ b/web/pgadmin/tools/debugger/static/js/components/Messages.jsx
@@ -0,0 +1,47 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { makeStyles } from '@material-ui/styles';
+import React from 'react';
+import { DebuggerEventsContext } from './DebuggerComponent';
+import { DEBUGGER_EVENTS } from '../DebuggerConstants';
+
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    whiteSpace: 'pre-wrap',
+    fontFamily: '"Source Code Pro", SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace',
+    padding: '5px 10px',
+    overflow: 'auto',
+    height: '100%',
+    fontSize: '12px',
+    userSelect: 'text',
+    backgroundColor: theme.palette.background.default,
+    color: theme.palette.text.primary,
+    ...theme.mixins.fontSourceCode,
+  }
+}));
+
+export default function DebuggerMessages() {
+  const classes = useStyles();
+  const [messageText, setMessageText] = React.useState('');
+  const eventBus = React.useContext(DebuggerEventsContext);
+  React.useEffect(()=>{
+    eventBus.registerListener(DEBUGGER_EVENTS.SET_MESSAGES, (text, append=false)=>{
+      setMessageText((prev)=>{
+        if(append) {
+          return prev+text;
+        }
+        return text;
+      });
+    });
+  }, []);
+  return (
+    <div className={classes.root} tabIndex="0" id='debugger-msg'>{messageText}</div>
+  );
+}
diff --git a/web/pgadmin/tools/debugger/static/js/components/Results.jsx b/web/pgadmin/tools/debugger/static/js/components/Results.jsx
new file mode 100644
index 00000000..90dee904
--- /dev/null
+++ b/web/pgadmin/tools/debugger/static/js/components/Results.jsx
@@ -0,0 +1,71 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import _ from 'lodash';
+import clsx from 'clsx';
+
+import React, { useState } from 'react';
+
+import { makeStyles } from '@material-ui/styles';
+import Paper from '@material-ui/core/Paper';
+
+import { DebuggerEventsContext } from './DebuggerComponent';
+import { DEBUGGER_EVENTS } from '../DebuggerConstants';
+import { commonTableStyles } from '../../../../../static/js/Theme';
+
+
+const useStyles = makeStyles(() => ({
+  table: {
+    minWidth: 650,
+  },
+  summaryContainer: {
+    flexGrow: 1,
+    minHeight: 0,
+    overflow: 'auto',
+  }
+}));
+
+export function Results() {
+  const classes = useStyles();
+  const tableClasses = commonTableStyles();
+  const eventBus = React.useContext(DebuggerEventsContext);
+  const [resultData, setResultData] = useState([]);
+  const [columns, setColumns] = useState([]);
+  React.useEffect(() => {
+    eventBus.registerListener(DEBUGGER_EVENTS.SET_RESULTS, (columnsData, values) => {
+      setResultData(values);
+      setColumns(columnsData);
+    });
+  }, []);
+  return (
+    <Paper variant="outlined" elevation={0} className={classes.summaryContainer}>
+      <table className={clsx(tableClasses.table)}>
+        <thead>
+          <tr key={_.uniqueId('c')}>
+            {
+              columns.map((col) => (
+                <th key={col.name}>{col.name}</th>
+              ))
+            }
+          </tr>
+        </thead>
+        <tbody>
+          {resultData.map((row) => (
+            <tr key={_.uniqueId('c')}>
+              {
+                columns.map((col) => (
+                  <td key={_.uniqueId('c')}>{row[col.name]}</td>
+                ))
+              }
+            </tr>
+          ))}
+        </tbody>
+      </table>
+    </Paper>
+  );
+}
diff --git a/web/pgadmin/tools/debugger/static/js/components/Stack.jsx b/web/pgadmin/tools/debugger/static/js/components/Stack.jsx
new file mode 100644
index 00000000..66214de2
--- /dev/null
+++ b/web/pgadmin/tools/debugger/static/js/components/Stack.jsx
@@ -0,0 +1,78 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import _ from 'lodash';
+import clsx from 'clsx';
+import gettext from 'sources/gettext';
+
+import React, { useState } from 'react';
+
+import { makeStyles } from '@material-ui/styles';
+import TableContainer from '@material-ui/core/TableContainer';
+import Paper from '@material-ui/core/Paper';
+
+import { DebuggerEventsContext } from './DebuggerComponent';
+import { DEBUGGER_EVENTS } from '../DebuggerConstants';
+import { commonTableStyles } from '../../../../../static/js/Theme';
+import { InputText } from '../../../../../static/js/components/FormComponents';
+
+
+const useStyles = makeStyles(() => ({
+  table: {
+    minWidth: 650,
+  },
+  summaryContainer: {
+    flexGrow: 1,
+    minHeight: 0,
+    overflow: 'auto',
+    maxHeight: '100%'
+  },
+  container: {
+    maxHeight: '100%'
+  }
+}));
+
+export function Stack() {
+  const classes = useStyles();
+  const tableClasses = commonTableStyles();
+  const eventBus = React.useContext(DebuggerEventsContext);
+  const [stackData, setStackData] = useState([]);
+  React.useEffect(() => {
+    eventBus.registerListener(DEBUGGER_EVENTS.SET_STACK, (stackValues) => {
+      setStackData(stackValues);
+    });
+  }, []);
+  return (
+    <Paper variant="outlined" elevation={0} className={classes.summaryContainer}>
+      <TableContainer className={classes.container}>
+        <table className={clsx(tableClasses.table)} aria-label="sticky table">
+          <thead>
+            <tr>
+              <th>{gettext('Name')}</th>
+              <th>{gettext('Value')}</th>
+              <th>{gettext('Line No.')}</th>
+            </tr>
+          </thead>
+          <tbody>
+            {stackData?.map((row, index) => (
+              <tr key={_.uniqueId('c')}>
+                <td>
+                  {row.targetname}
+                </td>
+                <td>{row.args}</td>
+                <td>
+                  <InputText data-test='stack-select-frame' value={row.linenumber} readonly={true} onClick={() => {eventBus.fireEvent(DEBUGGER_EVENTS.SET_FRAME, index);}}></InputText>
+                </td>
+              </tr>
+            ))}
+          </tbody>
+        </table>
+      </TableContainer>
+    </Paper>
+  );
+}
diff --git a/web/pgadmin/tools/debugger/static/js/components/ToolBar.jsx b/web/pgadmin/tools/debugger/static/js/components/ToolBar.jsx
new file mode 100644
index 00000000..661a12e1
--- /dev/null
+++ b/web/pgadmin/tools/debugger/static/js/components/ToolBar.jsx
@@ -0,0 +1,130 @@
+import React, { useCallback, useContext, useEffect, useState } from 'react';
+
+import { Box, makeStyles } from '@material-ui/core';
+import FormatIndentIncreaseIcon from '@material-ui/icons/FormatIndentIncrease';
+import FormatIndentDecreaseIcon from '@material-ui/icons/FormatIndentDecrease';
+import PlayCircleFilledWhiteIcon from '@material-ui/icons/PlayCircleFilledWhite';
+import FiberManualRecordIcon from '@material-ui/icons/FiberManualRecord';
+import NotInterestedIcon from '@material-ui/icons/NotInterested';
+import StopIcon from '@material-ui/icons/Stop';
+import HelpIcon from '@material-ui/icons/HelpRounded';
+
+import gettext from 'sources/gettext';
+import { shortcut_key } from 'sources/keyboard_shortcuts';
+import url_for from 'sources/url_for';
+
+import { PgButtonGroup, PgIconButton } from '../../../../../static/js/components/Buttons';
+import { DebuggerContext, DebuggerEventsContext } from './DebuggerComponent';
+import { DEBUGGER_EVENTS } from '../DebuggerConstants';
+
+const useStyles = makeStyles((theme) => ({
+  root: {
+    padding: '2px 4px',
+    display: 'flex',
+    alignItems: 'center',
+    gap: '4px',
+    backgroundColor: theme.otherVars.editorToolbarBg,
+    flexWrap: 'wrap',
+    ...theme.mixins.panelBorder.bottom,
+  },
+}));
+
+
+export function ToolBar() {
+  const classes = useStyles();
+  const debuggerCtx = useContext(DebuggerContext);
+  const eventBus = useContext(DebuggerEventsContext);
+  let preferences = debuggerCtx.preferences.debugger;
+
+  const [buttonsDisabled, setButtonsDisabled] = useState({
+    'stop': true,
+    'clear-all-breakpoints': true,
+    'toggle-breakpoint': true,
+    'start': true,
+    'step-over': true,
+    'step-into': true,
+  });
+
+  const setDisableButton = useCallback((name, disable = true) => {
+    setButtonsDisabled((prev) => ({ ...prev, [name]: disable }));
+  }, []);
+
+  const clearAllBreakpoint = useCallback(() => {
+    eventBus.fireEvent(DEBUGGER_EVENTS.TRIGGER_CLEAR_ALL_BREAKPOINTS);
+  }, []);
+
+  const toggleBreakpoint = useCallback(() => {
+    eventBus.fireEvent(DEBUGGER_EVENTS.TRIGGER_TOGGLE_BREAKPOINTS);
+  }, []);
+
+  const stop = useCallback(() => {
+    eventBus.fireEvent(DEBUGGER_EVENTS.TRIGGER_STOP_DEBUGGING);
+  });
+
+  const continueDebugger = useCallback(() => {
+    eventBus.fireEvent(DEBUGGER_EVENTS.TRIGGER_CONTINUE_DEBUGGING);
+  });
+
+
+  const stepOverDebugger = useCallback(() => {
+    eventBus.fireEvent(DEBUGGER_EVENTS.TRIGGER_STEPOVER_DEBUGGING);
+  });
+
+  const stepInTODebugger = useCallback(() => {
+    eventBus.fireEvent(DEBUGGER_EVENTS.TRIGGER_STEINTO_DEBUGGING);
+  });
+
+  const onHelpClick=()=>{
+    let url = url_for('help.static', {'filename': 'debugger.html'});
+    window.open(url, 'pgadmin_help');
+  };
+
+  useEffect(() => {
+    eventBus.registerListener(DEBUGGER_EVENTS.DISABLE_MENU, () => {
+      setDisableButton('start', true);
+      setDisableButton('step-into', true);
+      setDisableButton('step-over', true);
+      setDisableButton('clear-all-breakpoints', true);
+      setDisableButton('toggle-breakpoint', true);
+      setDisableButton('stop', true);
+    });
+
+    eventBus.registerListener(DEBUGGER_EVENTS.ENABLE_MENU, () => {
+      setDisableButton('start', false);
+      setDisableButton('step-into', false);
+      setDisableButton('step-over', false);
+      setDisableButton('clear-all-breakpoints', false);
+      setDisableButton('toggle-breakpoint', false);
+      setDisableButton('stop', false);
+    });
+
+    eventBus.registerListener(DEBUGGER_EVENTS.ENABLE_SPECIFIC_MENU, (key) => {
+      setDisableButton(key, false);
+    });
+  }, []);
+
+
+  return (
+    <Box className={classes.root}>
+      <PgButtonGroup size="small">
+        <PgIconButton data-test='step-in' title={gettext('Step into')} disabled={buttonsDisabled['step-into']} icon={<FormatIndentIncreaseIcon />} onClick={() => { stepInTODebugger(); }}
+          accesskey={shortcut_key(preferences?.btn_step_into)} />
+        <PgIconButton data-test='step-over' title={gettext('Step over')} disabled={buttonsDisabled['step-over']} icon={<FormatIndentDecreaseIcon />} onClick={() => { stepOverDebugger(); }}
+          accesskey={shortcut_key(preferences?.btn_step_over)} />
+        <PgIconButton data-test='debugger-contiue' title={gettext('Continue/Start')} disabled={buttonsDisabled['start']} icon={<PlayCircleFilledWhiteIcon />} onClick={() => { continueDebugger(); }}
+          accesskey={shortcut_key(preferences?.btn_start)} />
+      </PgButtonGroup>
+      <PgButtonGroup size="small">
+        <PgIconButton data-test='toggle-breakpoint' title={gettext('Toggle breakpoint')} disabled={buttonsDisabled['toggle-breakpoint']} icon={<FiberManualRecordIcon />}
+          accesskey={shortcut_key(preferences?.btn_toggle_breakpoint)} onClick={() => { toggleBreakpoint(); }} />
+        <PgIconButton data-test='clear-breakpoint' title={gettext('Clear all breakpoints')} disabled={buttonsDisabled['clear-all-breakpoints']} icon={<NotInterestedIcon />}
+          accesskey={shortcut_key(preferences?.btn_clear_breakpoints)} onClick={() => { clearAllBreakpoint(); }} />
+        <PgIconButton data-test='stop-debugger' title={gettext('Stop')} icon={<StopIcon />} disabled={buttonsDisabled['stop']} onClick={() => { stop(); }}
+          accesskey={shortcut_key(preferences?.btn_stop)} />
+      </PgButtonGroup>
+      <PgButtonGroup size="small">
+        <PgIconButton data-test='debugger-help' title={gettext('Help')} icon={<HelpIcon />} onClick={onHelpClick} />
+      </PgButtonGroup>
+    </Box>
+  );
+}
\ No newline at end of file
